/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.persontoemployeeconverter;


import java.util.List;
import java.util.stream.Collectors;

/**
 *
 * @author omozegieaziegbe
 */
public class PersonToEmployeeConverter {

    public static void main(String[] args) {
        
        // Sample list of Person objects
        List<Person> persons = List.of(
                new Person("Thomas", 30),
                new Person("Sarah", 25),
                new Person("Bill", 35)
        );

        // Convert List<Person> to List<Employee> using Java streams
        List<Employee> employees = persons.stream()
                .map(person -> new Employee(person.getName(), person.getAge(), generateEmployeeId()))
                .collect(Collectors.toList());

        // Print the result
        employees.forEach(employee -> System.out.println("Employee: " + employee.getName() +
                ", Age: " + employee.getAge() +
                ", Employee ID: " + employee.getEmployeeId()));
    }

    // A simple method to generate unique employee IDs
    private static int generateEmployeeId() {
        
        // return a random number for demonstration purposes
        return (int) (Math.random() * 1000);
    }
}